// DigiFrX.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "defs.h"
#include "ProtocolFR.h"
#include "ServiceFR.h"
#include "ProtocolX25.h"
#include "ServiceX25.h"

#if defined NT5
#include "ServiceX25Svc.h"
#endif // #if defined NT5

#include "pvc.h"
#include "router.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HINSTANCE g_hInstance = NULL;

static AFX_EXTENSION_MODULE DigiFrXDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("DIGIFRX.DLL Initializing!\n");
		
		g_hInstance = hInstance;
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(DigiFrXDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(DigiFrXDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("DIGIFRX.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(DigiFrXDLL);
	}
	return 1;   // ok
}

BOOL APIENTRY NewObj(CConfigObject const ** const ppObj, CString const & strName, HKEY const hKeyRoot, CString const & strRegPath, CConfigObject const * const pParent)
{
   BOOL fSuccess = FALSE;

   TRACE("SRVFRX25.DLL: NewObj(%s)\n", (LPCTSTR)strName);

   try
   {
      AffirmThrow(ppObj != NULL);
#if defined(_DEBUG)
      if (*ppObj != NULL) TRACE("*ppObj != NULL\n");
#endif

      CConfigObject * pNewObj = NULL;

	  if (strName == DXB_REGVAL_PROTOCOL_ENUM_FRAMERELAY)
		  pNewObj = new CProtocolFR(hKeyRoot,strRegPath,pParent);
	  else if (strName == DXB_REGVAL_LINE_SERVICE_FR)
		  pNewObj = new CServiceFR(hKeyRoot,strRegPath,pParent);
	  else if (strName == DXB_REGVAL_PORT_TYPE_FR)
		  pNewObj = new CPortFR(hKeyRoot,strRegPath,pParent);
	  else if (strName == DXB_REGVAL_PROTOCOL_ENUM_X25)
		  pNewObj = new CProtocolX25(hKeyRoot,strRegPath,pParent);
	  else if (strName == DXB_REGVAL_LINE_SERVICE_X25)
		  pNewObj = new CServiceX25(hKeyRoot,strRegPath,pParent);
#if defined NT5
	  else if (strName == DXB_REGVAL_LINE_SERVICE_X25_SVC)
		  pNewObj = new CServiceX25Svc(hKeyRoot,strRegPath,pParent);
#endif // #if defined NT5
	  else if (strName == DXB_REGVAL_PORT_TYPE_X25)
		  pNewObj = new CPortX25(hKeyRoot,strRegPath,pParent);
	  else if (strName == DXB_REGVAL_ROUTER_TYPE_WANX)
		  pNewObj = new CX25Router(hKeyRoot,strRegPath,pParent);
	  else
		  AffirmThrow(FALSE);

      AffirmThrow(pNewObj != NULL);
      *ppObj  = pNewObj;
      fSuccess = TRUE;
   }
   catch (CAffirmException ae)
   {
   }

   return fSuccess;
}


void APIENTRY DeleteObj(CConfigObject const ** const ppObj)
{
   TRACE("SRVSNA.DLL: DeleteObj()\n");

   try
   {
      AffirmThrow(ppObj != NULL);
      AffirmThrow(*ppObj != NULL);

      delete *ppObj;
      *ppObj = NULL;
   }
   catch (CAffirmException ae)
   {
   }

   return;
}
